OGRE-Next: Ogre::ParticleSystem Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Member Functions | Static Public Member Functions | List of all members
Ogre::ParticleSystem Class Reference
Core » Effects

Class defining particle system based special effects. More...

`#include <OgreParticleSystem.h>`

Inheritance diagram for Ogre::ParticleSystem:
[legend]

## Classes
class | CmdCull
| Command object for cull_each (see ParamCommand). More...
class | CmdEmittedEmitterQuota
| Command object for emittedEmitterQuota (see ParamCommand). More...
class | CmdHeight
| Command object for particle_height (see ParamCommand). More...
class | CmdIterationInterval
| Command object for iteration interval(see ParamCommand). More...
class | CmdLocalSpace
| Command object for local space (see ParamCommand). More...
class | CmdMaterial
| Command object for material (see ParamCommand). More...
class | CmdNonvisibleTimeout
| Command object for nonvisible timeout (see ParamCommand). More...
class | CmdQuota
| Command object for quota (see ParamCommand). More...
class | CmdRenderer
| Command object for renderer (see ParamCommand). More...
class | CmdSorted
| Command object for sorting (see ParamCommand). More...
class | CmdWidth
| Command object for particle_width (see ParamCommand). More...

## Public Member Functions
| ParticleSystem (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, const String &resourceGroupName)
| Creates a particle system with no emitters or affectors.
virtual | ~ParticleSystem () override
ParticleIterator | _getIterator ()
| Returns an iterator for stepping through all particles in this system.
void | _notifyAttached (Node *parent) override
| Overridden from MovableObject.
void | _notifyOrigin (const String &origin)
| Notify this particle system of it's origin.
virtual void | _notifyParticleResized ()
| Internal callback used by Particles to notify their parent that they have been resized.
virtual void | _notifyParticleRotated ()
| Internal callback used by Particles to notify their parent that they have been rotated.
void | _update (Real timeElapsed)
| Updates the particles in the system based on time elapsed.
void | _updateBounds ()
| Internal method for updating the bounds of the particle system.
void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera) override
| Overridden from MovableObject.
ParticleAffector * | addAffector (const String &affectorType)
| Adds an affector to this particle system.
ParticleEmitter * | addEmitter (const String &emitterType)
| Adds an emitter to this particle system.
void | clear ()
| Empties this set of all particles.
Particle * | createEmitterParticle (const String &emitterName)
| Manually add an emitter particle to the system.
Particle * | createParticle ()
| Manually add a particle to the system.
void | fastForward (Real time, Real interval=Real(0.1))
| Fast-forwards this system by the required number of seconds.
ParticleAffector * | getAffector (unsigned short index) const
| Retrieves an affector by it's index (zero-based).
virtual bool | getCullIndividually () const
| Returns whether or not particles in this are tested individually for culling.
virtual Real | getDefaultHeight () const
| See setDefaultDimensions - this gets 1 component individually.
virtual Real | getDefaultWidth () const
| See setDefaultDimensions - this gets 1 component individually.
size_t | getEmittedEmitterQuota () const
| Returns the maximum number of emitted emitters this system is allowed to have active at once.
ParticleEmitter * | getEmitter (unsigned short index) const
| Retrieves an emitter by it's index (zero-based).
bool | getEmitting () const
| Returns true if the particle system emitting flag is turned on.
Real | getIterationInterval () const
| Gets a 'iteration interval' on this particle system.
bool | getKeepParticlesInLocalSpace () const
| Gets whether particles (and any affector effects) remain relative to the node the particle system is attached to.
virtual const String & | getMaterialName () const
| Sets the name of the material to be used for this billboard set.
const String & | getMovableType () const override
| Overridden from MovableObject.
Real | getNonVisibleUpdateTimeout () const
| Gets when the particle system should stop updating after it hasn't been visible for a while.
unsigned short | getNumAffectors () const
| Returns the number of affectors for this particle system.
unsigned short | getNumEmitters () const
| Returns the number of emitters for this particle system.
size_t | getNumParticles () const
| Gets the number of individual particles in the system right now.
const String & | getOrigin () const
| Get the origin of this particle system, e.g.
Particle * | getParticle (size_t index)
| Retrieve a particle from the system for manual tweaking.
SceneNode * | getParticleEmitterRootNode () const
| This is used to attach the particle Emmiters to an own node independent from the Scenenode the Particlesystem is attached to.
size_t | getParticleQuota () const
| Returns the maximum number of particles this system is allowed to have active at once.
ParticleSystemRenderer * | getRenderer () const
| Gets the ParticleRenderer to be used to render this particle system.
const String & | getRendererName () const
| Gets the name of the ParticleRenderer to be used to render this particle system.
virtual const String & | getResourceGroupName () const
| Return the resource group to be used to load dependent resources.
bool | getSortingEnabled () const
| Gets whether particles are sorted relative to the camera.
Real | getSpeedFactor () const
| Gets the 'speed factor' on this particle system.
bool | getTranslateParticleDirectionIntoWorldSpace () const
| Gets whether particles emitts in direction with is translated into worldspace or not (may only apply to some settings in regards of settings "Localspace" and "ParticleEmitterRootNode")
ParticleSystem & | operator= (const ParticleSystem &rhs)
| Assignment operator for copying.
void | removeAffector (unsigned short index)
| Removes an affector from the system.
void | removeAllAffectors ()
| Removes all the affectors from this system.
void | removeAllEmitters ()
| Removes all the emitters from this system.
void | removeEmitter (ParticleEmitter *emitter)
| Removes an emitter from the system.
void | removeEmitter (unsigned short index)
| Removes an emitter from the system.
void | setBoundsAutoUpdated (bool autoUpdate, Real stopIn=0.0f)
| Sets whether the bounds will be automatically updated for the life of the particle system.
virtual void | setCullIndividually (bool cullIndividual)
| Sets whether culling tests particles in this individually as well as in a group.
virtual void | setDefaultDimensions (Real width, Real height)
| Sets the default dimensions of the particles in this set.
virtual void | setDefaultHeight (Real height)
| See setDefaultDimensions - this sets 1 component individually.
virtual void | setDefaultWidth (Real width)
| See setDefaultDimensions - this sets 1 component individually.
void | setEmittedEmitterQuota (size_t quota)
| Sets the maximum number of emitted emitters this system is allowed to have active at once.
void | setEmitting (bool v)
| This is used to turn on or off particle emission for this system.
void | setIterationInterval (Real iterationInterval)
| Sets a 'iteration interval' on this particle system.
void | setKeepParticlesInLocalSpace (bool keepLocal)
| Sets whether particles (and any affector effects) remain relative to the node the particle system is attached to.
virtual void | setMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Sets the name of the material to be used for this billboard set.
void | setNonVisibleUpdateTimeout (Real timeout)
| Sets when the particle system should stop updating after it hasn't been visible for a while.
void | setParticleEmitterRootNode (SceneNode *sceneNode)
| This is used to attach the particle Emmiters to an own node independent from the Scenenode the Particlesystem is attached to.
void | setParticleQuota (size_t quota)
| Sets the maximum number of particles this system is allowed to have active at once.
void | setRenderer (const String &typeName)
| Sets the ParticleRenderer to be used to render this particle system.
void | setRenderQueueGroup (uint8 queueID) override
| Sets the render queue group this entity will be rendered through.
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group.
void | setSortingEnabled (bool enabled)
| Set whether or not particles are sorted according to the camera.
void | setSpeedFactor (Real speedFactor)
| Sets a 'speed factor' on this particle system, which means it scales the elapsed real time which has passed by this factor before passing it to the emitters, affectors, and the particle life calculation.
void | setTranslateParticleDirectionIntoWorldSpace (bool value)
| Sets whether particles emitts in direction with is translated into worldspace or not (may only apply to some settings in regards of settings "Localspace" and "ParticleEmitterRootNode")
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, uint8 renderQueueId)
| Constructor.
| MovableObject (ObjectData *objectDataPtrs)
| Don't use this constructor unless you know what you're doing.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager () const
| Get the manager of this object, if any (internal use only)
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state.
const Matrix4 & | _getParentNodeFullTransform () const
| Returns the full transformation of the parent sceneNode or the attachingPoint node.
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only)
virtual void | _notifyParentNodeMemoryChanged ()
virtual void | _notifyStaticDirty () const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent ()
| Detaches an object from a parent SceneNode if attached.
RealAsUint | getCachedDistanceToCamera () const
| Returns the distance to camera as calculated in cullFrustum()
Real | getCachedDistanceToCameraAsReal () const
| Returns the distance to camera as calculated in cullFrustum()
bool | getCastShadows () const
| Returns whether shadow casting is enabled for this object.
unsigned char | getCurrentMeshLod () const
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener () const
| Gets the current listener for this object.
Aabb | getLocalAabb () const
| Retrieves the local axis-aligned bounding box for this object.
float | getLocalRadius () const
| See getLocalAabb and getWorldRadius.
const String & | getName () const
| Returns the name of this object.
Node * | getParentNode () const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode () const
uint32 | getQueryFlags () const
| Returns the query flags relevant for this object.
Real | getRenderingDistance () const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup () const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
Real | getShadowRenderingDistance () const
| Gets the distance at which batches are no longer casting shadows.
SkeletonInstance * | getSkeletonInstance () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
uint32 | getVisibilityFlags () const
| Returns the visibility flags relevant for this object.
bool | getVisible () const
| Gets this object whether to be visible or not, if it has a renderable component.
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space.
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space.
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
bool | isAttached () const
| Returns true if this object is attached to a Node.
bool | isStatic () const
| Checks whether this MovableObject is static.
bool | isVisible () const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights () const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object.
void | setName (const String &name)
| Sets a custom name for this node.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows.
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic.
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
const StringVector & | getAnimableValueNames () const
| Gets a list of animable value names for this object.
Public Member Functions inherited from Ogre::IdObject
| IdObject (IdType id)
| We don't call generateNewId() here, to prevent objects in the stack (i.e.
IdType | getId () const
| Get the unique id of this object.
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)

## Static Public Member Functions
static Real | getDefaultIterationInterval ()
| Get the default iteration interval for all ParticleSystem instances.
static Real | getDefaultNonVisibleUpdateTimeout ()
| Get the default nonvisible timeout for all ParticleSystem instances.
static void | setDefaultIterationInterval (Real iterationInterval)
| Set the default iteration interval for all ParticleSystem instances.
static void | setDefaultNonVisibleUpdateTimeout (Real timeout)
| Set the default nonvisible timeout for all ParticleSystem instances.
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Static Public Member Functions inherited from Ogre::MovableObject
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| See SceneManager::cullLights & see MovableObject::cullFrustum.
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static void | updateAllBounds (const size_t numNodes, ObjectData t)

## Additional Inherited Members
Public Types inherited from Ogre::MovableObject
typedef FastArray< MovableObject * > | MovableObjectArray
Public Attributes inherited from Ogre::MovableObject
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
RenderableArray | mRenderables
Static Public Attributes inherited from Ogre::MovableObject
static const FastArray< Real > | c_DefaultLodMesh

## Detailed Description

Class defining particle system based special effects.

Remarks
  Particle systems are special effects generators which are based on a number of moving points to create the impression of things like like sparkles, smoke, blood spurts, dust etc.

  This class simply manages a single collection of particles in world space with a shared local origin for emission. The visual aspect of the particles is handled by a ParticleSystemRenderer instance.

  Particle systems are created using the SceneManager, never directly. In addition, like all subclasses of MovableObject, the ParticleSystem will only be considered for rendering once it has been attached to a SceneNode.

## Constructor & Destructor Documentation

## ◆ ParticleSystem()

Ogre::ParticleSystem::ParticleSystem | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | manager,
|  | const String & | resourceGroupName )

Creates a particle system with no emitters or affectors.

Remarks
  You should use the ParticleSystemManager to create particle systems rather than creating them directly.

Referenced by operator=().

## ◆ ~ParticleSystem()

virtual Ogre::ParticleSystem::~ParticleSystem | ( |  | ) |
| overridevirtual

## Member Function Documentation

## ◆ _getIterator()

ParticleIterator Ogre::ParticleSystem::_getIterator | ( |  | ) |

Returns an iterator for stepping through all particles in this system.

Remarks
  This method is designed to be used by people providing new ParticleAffector subclasses, this is the easiest way to step through all the particles in a system and apply the changes the affector wants to make.

## ◆ _notifyAttached()

void Ogre::ParticleSystem::_notifyAttached | ( | Node * | parent | ) |
| overridevirtual

Overridden from MovableObject.

See also
  MovableObject

Reimplemented from Ogre::MovableObject.

## ◆ _notifyOrigin()

void Ogre::ParticleSystem::_notifyOrigin | ( | const String & | origin | ) |
| inline

Notify this particle system of it's origin.

## ◆ _notifyParticleResized()

virtual void Ogre::ParticleSystem::_notifyParticleResized | ( |  | ) |
| virtual

Internal callback used by Particles to notify their parent that they have been resized.

## ◆ _notifyParticleRotated()

virtual void Ogre::ParticleSystem::_notifyParticleRotated | ( |  | ) |
| virtual

Internal callback used by Particles to notify their parent that they have been rotated.

## ◆ _update()

void Ogre::ParticleSystem::_update | ( | Real | timeElapsed | ) |

Updates the particles in the system based on time elapsed.

Remarks
  This is called automatically every frame by OGRE.

Parameters

  timeElapsed | The amount of time, in seconds, since the last frame.

## ◆ _updateBounds()

void Ogre::ParticleSystem::_updateBounds | ( |  | ) |

Internal method for updating the bounds of the particle system.

Remarks
  This is called automatically for a period of time after the system's creation (10 seconds by default, settable by setBoundsAutoUpdated) to increase (and only increase) the bounds of the system according to the emitted and affected particles. After this period, the system is assumed to achieved its maximum size, and the bounds are no longer computed for efficiency. You can tweak the behaviour by either setting the bounds manually (setBounds, preferred), or changing the time over which the bounds are updated (performance cost). You can also call this method manually if you need to update the bounds on an ad-hoc basis.

## ◆ _updateRenderQueue()

void Ogre::ParticleSystem::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera )
| overridevirtual

Overridden from MovableObject.

See also
  MovableObject

Reimplemented from Ogre::MovableObject.

## ◆ addAffector()

ParticleAffector * Ogre::ParticleSystem::addAffector | ( | const String & | affectorType | ) |

Adds an affector to this particle system.

Remarks
  Particles are modified over time in a particle system by affectors - see the ParticleAffector class for more details.

Parameters

  affectorType | String identifying the affector type to create. Affector types are defined by registering new factories with the manager - see ParticleAffectorFactory for more details. Affector types can be extended by OGRE, plugin authors or application developers.

## ◆ addEmitter()

ParticleEmitter * Ogre::ParticleSystem::addEmitter | ( | const String & | emitterType | ) |

Adds an emitter to this particle system.

Remarks
  Particles are created in a particle system by emitters - see the ParticleEmitter class for more details.

Parameters

  emitterType | String identifying the emitter type to create. Emitter types are defined by registering new factories with the manager - see ParticleEmitterFactory for more details. Emitter types can be extended by OGRE, plugin authors or application developers.

## ◆ clear()

void Ogre::ParticleSystem::clear | ( |  | ) |

Empties this set of all particles.

## ◆ createEmitterParticle()

Particle * Ogre::ParticleSystem::createEmitterParticle | ( | const String & | emitterName | ) |

Manually add an emitter particle to the system.

Remarks
  The purpose of a particle emitter is to emit particles. Besides visual particles, also other other particle types can be emitted, other emitters for example. The emitted emitters have a double role; they behave as particles and can be influenced by affectors, but they are still emitters and capable to emit other particles (or emitters). It is possible to create a chain of emitters - emitters emitting other emitters, which also emit emitters.

Parameters

  emitterName | The name of a particle emitter that must be emitted.

## ◆ createParticle()

Particle * Ogre::ParticleSystem::createParticle | ( |  | ) |

Manually add a particle to the system.

Remarks
  Instead of using an emitter, you can manually add a particle to the system. You must initialise the returned particle instance immediately with the 'emission' state.

Note
  There is no corresponding 'destroyParticle' method - if you want to dispose of a particle manually (say, if you've used setSpeedFactor(0) to make particles live forever) you should use getParticle() and modify it's timeToLive to zero, meaning that it will get cleaned up in the next update.

## ◆ fastForward()

void Ogre::ParticleSystem::fastForward | ( | Real | time,
|  | Real | interval = Real(0.1) )

Fast-forwards this system by the required number of seconds.

Remarks
  This method allows you to fast-forward a system so that it effectively looks like it has already been running for the time you specify. This is useful to avoid the 'startup sequence' of a system, when you want the system to be fully populated right from the start.

Parameters

  time | The number of seconds to fast-forward by.
  interval | The sampling interval used to generate particles, apply affectors etc. The lower this is the more realistic the fast-forward, but it takes more iterations to do it.

## ◆ getAffector()

ParticleAffector * Ogre::ParticleSystem::getAffector | ( | unsigned short | index | ) | const

Retrieves an affector by it's index (zero-based).

Remarks
  Used to retrieve a pointer to an affector for a particle system to procedurally change affector parameters etc. You should check how many affectors are registered against this system before calling this method with an arbitrary index using getNumAffectors.

Parameters

  index | Zero-based index of the affector to retrieve.

## ◆ getCullIndividually()

virtual bool Ogre::ParticleSystem::getCullIndividually | ( |  | ) | const
| virtual

Returns whether or not particles in this are tested individually for culling.

## ◆ getDefaultHeight()

virtual Real Ogre::ParticleSystem::getDefaultHeight | ( |  | ) | const
| virtual

See setDefaultDimensions - this gets 1 component individually.

## ◆ getDefaultIterationInterval()

static Real Ogre::ParticleSystem::getDefaultIterationInterval | ( |  | ) |
| inlinestatic

Get the default iteration interval for all ParticleSystem instances.

## ◆ getDefaultNonVisibleUpdateTimeout()

static Real Ogre::ParticleSystem::getDefaultNonVisibleUpdateTimeout | ( |  | ) |
| inlinestatic

Get the default nonvisible timeout for all ParticleSystem instances.

## ◆ getDefaultWidth()

virtual Real Ogre::ParticleSystem::getDefaultWidth | ( |  | ) | const
| virtual

See setDefaultDimensions - this gets 1 component individually.

## ◆ getEmittedEmitterQuota()

size_t Ogre::ParticleSystem::getEmittedEmitterQuota | ( |  | ) | const

Returns the maximum number of emitted emitters this system is allowed to have active at once.

Remarks
  See ParticleSystem::setEmittedEmitterQuota for more info.

## ◆ getEmitter()

ParticleEmitter * Ogre::ParticleSystem::getEmitter | ( | unsigned short | index | ) | const

Retrieves an emitter by it's index (zero-based).

Remarks
  Used to retrieve a pointer to an emitter for a particle system to procedurally change emission parameters etc. You should check how many emitters are registered against this system before calling this method with an arbitrary index using getNumEmitters.

Parameters

  index | Zero-based index of the emitter to retrieve.

## ◆ getEmitting()

bool Ogre::ParticleSystem::getEmitting | ( |  | ) | const

Returns true if the particle system emitting flag is turned on.

Remarks
  This function will not actually return whether the particles are being emitted. It only returns the value of emitting flag.

## ◆ getIterationInterval()

Real Ogre::ParticleSystem::getIterationInterval | ( |  | ) | const
| inline

Gets a 'iteration interval' on this particle system.

## ◆ getKeepParticlesInLocalSpace()

bool Ogre::ParticleSystem::getKeepParticlesInLocalSpace | ( |  | ) | const
| inline

Gets whether particles (and any affector effects) remain relative to the node the particle system is attached to.

## ◆ getMaterialName()

virtual const String & Ogre::ParticleSystem::getMaterialName | ( |  | ) | const
| virtual

Sets the name of the material to be used for this billboard set.

Returns
  The name of the material that is used for this set.

## ◆ getMovableType()

const String & Ogre::ParticleSystem::getMovableType | ( |  | ) | const
| overridevirtual

Overridden from MovableObject.

Implements Ogre::MovableObject.

## ◆ getNonVisibleUpdateTimeout()

Real Ogre::ParticleSystem::getNonVisibleUpdateTimeout | ( |  | ) | const
| inline

Gets when the particle system should stop updating after it hasn't been visible for a while.

## ◆ getNumAffectors()

unsigned short Ogre::ParticleSystem::getNumAffectors | ( |  | ) | const

Returns the number of affectors for this particle system.

## ◆ getNumEmitters()

unsigned short Ogre::ParticleSystem::getNumEmitters | ( |  | ) | const

Returns the number of emitters for this particle system.

## ◆ getNumParticles()

size_t Ogre::ParticleSystem::getNumParticles | ( |  | ) | const

Gets the number of individual particles in the system right now.

Remarks
  The number of particles active in a system at a point in time depends on the number of emitters, their emission rates, the time-to-live (TTL) each particle is given on emission (and whether any affectors modify that TTL) and the maximum number of particles allowed in this system at once (particle quota).

## ◆ getOrigin()

const String & Ogre::ParticleSystem::getOrigin | ( |  | ) | const
| inline

Get the origin of this particle system, e.g.

a script file name.

Remarks
  This property will only contain something if the creator of this particle system chose to populate it. Script loaders are advised to populate it.

## ◆ getParticle()

Particle * Ogre::ParticleSystem::getParticle | ( | size_t | index | ) |

Retrieve a particle from the system for manual tweaking.

Remarks
  Normally you use an affector to alter particles in flight, but for small manually controlled particle systems you might want to use this method.

## ◆ getParticleEmitterRootNode()

SceneNode * Ogre::ParticleSystem::getParticleEmitterRootNode | ( |  | ) | const

This is used to attach the particle Emmiters to an own node independent from the Scenenode the Particlesystem is attached to.

Remarks
  In case this scenenode is not NULL, particles will be emmitted relative to this node instead of relative to the Scenenode the Particlesystem is attached to.

## ◆ getParticleQuota()

size_t Ogre::ParticleSystem::getParticleQuota | ( |  | ) | const

Returns the maximum number of particles this system is allowed to have active at once.

Remarks
  See ParticleSystem::setParticleQuota for more info.

## ◆ getRenderer()

ParticleSystemRenderer * Ogre::ParticleSystem::getRenderer | ( |  | ) | const

Gets the ParticleRenderer to be used to render this particle system.

## ◆ getRendererName()

const String & Ogre::ParticleSystem::getRendererName | ( |  | ) | const

Gets the name of the ParticleRenderer to be used to render this particle system.

## ◆ getResourceGroupName()

virtual const String & Ogre::ParticleSystem::getResourceGroupName | ( |  | ) | const
| inlinevirtual

Return the resource group to be used to load dependent resources.

## ◆ getSortingEnabled()

bool Ogre::ParticleSystem::getSortingEnabled | ( |  | ) | const
| inline

Gets whether particles are sorted relative to the camera.

## ◆ getSpeedFactor()

Real Ogre::ParticleSystem::getSpeedFactor | ( |  | ) | const
| inline

Gets the 'speed factor' on this particle system.

## ◆ getTranslateParticleDirectionIntoWorldSpace()

bool Ogre::ParticleSystem::getTranslateParticleDirectionIntoWorldSpace | ( |  | ) | const
| inline

Gets whether particles emitts in direction with is translated into worldspace or not (may only apply to some settings in regards of settings "Localspace" and "ParticleEmitterRootNode")

## ◆ operator=()

ParticleSystem & Ogre::ParticleSystem::operator= | ( | const ParticleSystem & | rhs | ) |

Assignment operator for copying.

Remarks
  This operator deep copies all particle emitters and effectors, but not particles. The system's name is also not copied.

References ParticleSystem().

## ◆ removeAffector()

void Ogre::ParticleSystem::removeAffector | ( | unsigned short | index | ) |

Removes an affector from the system.

Remarks
  Drops the affector with the index specified from this system. You should check how many affectors are registered against this system before calling this method with an arbitrary index using getNumAffectors.

Parameters

  index | Zero-based index of the affector to retrieve.

## ◆ removeAllAffectors()

void Ogre::ParticleSystem::removeAllAffectors | ( |  | ) |

Removes all the affectors from this system.

## ◆ removeAllEmitters()

void Ogre::ParticleSystem::removeAllEmitters | ( |  | ) |

Removes all the emitters from this system.

## ◆ removeEmitter() [1/2]

void Ogre::ParticleSystem::removeEmitter | ( | ParticleEmitter * | emitter | ) |

Removes an emitter from the system.

Remarks
  Drops the emitter from this system.

Parameters

  emitter | Pointer to a particle emitter.

## ◆ removeEmitter() [2/2]

void Ogre::ParticleSystem::removeEmitter | ( | unsigned short | index | ) |

Removes an emitter from the system.

Remarks
  Drops the emitter with the index specified from this system. You should check how many emitters are registered against this system before calling this method with an arbitrary index using getNumEmitters.

Parameters

  index | Zero-based index of the emitter to retrieve.

## ◆ setBoundsAutoUpdated()

void Ogre::ParticleSystem::setBoundsAutoUpdated | ( | bool | autoUpdate,
|  | Real | stopIn = 0.0f )

Sets whether the bounds will be automatically updated for the life of the particle system.

Remarks
  If you have a stationary particle system, it would be a good idea to call this method and set the value to 'false', since the maximum bounds of the particle system will eventually be static. If you do this, you can either set the bounds manually using the setBounds() method, or set the second parameter of this method to a positive number of seconds, so that the bounds are calculated for a few seconds and then frozen.

Parameters

  autoUpdate | If true (the default), the particle system will update it's bounds every frame. If false, the bounds update will cease after the 'stopIn' number of seconds have passed.
  stopIn | Only applicable if the first parameter is true, this is the number of seconds after which the automatic update will cease.

## ◆ setCullIndividually()

virtual void Ogre::ParticleSystem::setCullIndividually | ( | bool | cullIndividual | ) |
| virtual

Sets whether culling tests particles in this individually as well as in a group.

Remarks
  Particle sets are always culled as a whole group, based on a bounding box which encloses all particles in the set. For fairly localised sets, this is enough. However, you can optionally tell the set to also cull individual particles in the set, i.e. to test each individual particle before rendering. The default is not to do this.

  This is useful when you have a large, fairly distributed set of particles, like maybe trees on a landscape. You probably still want to group them into more than one set (maybe one set per section of landscape), which will be culled coarsely, but you also want to cull the particles individually because they are spread out. Whilst you could have lots of single-tree sets which are culled separately, this would be inefficient to render because each tree would be issued as it's own rendering operation.

  By calling this method with a parameter of true, you can have large particle sets which are spaced out and so get the benefit of batch rendering and coarse culling, but also have fine-grained culling so unnecessary rendering is avoided.

Parameters

  cullIndividual | If true, each particle is tested before being sent to the pipeline as well as the whole set having to pass the coarse group bounding test.

## ◆ setDefaultDimensions()

virtual void Ogre::ParticleSystem::setDefaultDimensions | ( | Real | width,
|  | Real | height )
| virtual

Sets the default dimensions of the particles in this set.

Remarks
  All particles in a set are created with these default dimensions. The set will render most efficiently if all the particles in the set are the default size. It is possible to alter the size of individual particles at the expense of extra calculation. See the Particle class for more info.

Parameters

  width | The new default width for the particles in this set. Must be non-negative!
  height | The new default height for the particles in this set. Must be non-negative!

## ◆ setDefaultHeight()

virtual void Ogre::ParticleSystem::setDefaultHeight | ( | Real | height | ) |
| virtual

See setDefaultDimensions - this sets 1 component individually.

## ◆ setDefaultIterationInterval()

static void Ogre::ParticleSystem::setDefaultIterationInterval | ( | Real | iterationInterval | ) |
| inlinestatic

Set the default iteration interval for all ParticleSystem instances.

## ◆ setDefaultNonVisibleUpdateTimeout()

static void Ogre::ParticleSystem::setDefaultNonVisibleUpdateTimeout | ( | Real | timeout | ) |
| inlinestatic

Set the default nonvisible timeout for all ParticleSystem instances.

## ◆ setDefaultWidth()

virtual void Ogre::ParticleSystem::setDefaultWidth | ( | Real | width | ) |
| virtual

See setDefaultDimensions - this sets 1 component individually.

## ◆ setEmittedEmitterQuota()

void Ogre::ParticleSystem::setEmittedEmitterQuota | ( | size_t | quota | ) |

Sets the maximum number of emitted emitters this system is allowed to have active at once.

Remarks
  Particle systems can have - besides a particle quota - also an emitted emitter quota.

Parameters

  quota | The maximum number of emitted emitters this system is allowed to have.

## ◆ setEmitting()

void Ogre::ParticleSystem::setEmitting | ( | bool | v | ) |

This is used to turn on or off particle emission for this system.

Remarks
  By default particle system is always emitting particles (if a emitters exists) and this can be used to stop the emission for all emitters. To turn it on again, call it passing true.

Note that this does not detach the particle system from the scene node, it will still use some CPU.

## ◆ setIterationInterval()

void Ogre::ParticleSystem::setIterationInterval | ( | Real | iterationInterval | ) |

Sets a 'iteration interval' on this particle system.

Remarks
  The default Particle system update interval, based on elapsed frame time, will cause different behavior between low frame-rate and high frame-rate. By using this option, you can make the particle system update at a fixed interval, keeping the behavior the same no matter what frame-rate is.

  When iteration interval is set to zero, it means the update occurs based on an elapsed frame time, otherwise each iteration will take place at the given interval, repeating until it has used up all the elapsed frame time.

Parameters

  iterationInterval | The iteration interval, default to zero.

## ◆ setKeepParticlesInLocalSpace()

void Ogre::ParticleSystem::setKeepParticlesInLocalSpace | ( | bool | keepLocal | ) |

Sets whether particles (and any affector effects) remain relative to the node the particle system is attached to.

Remarks
  By default particles are in world space once emitted, so they are not affected by movement in the parent node of the particle system. This makes the most sense when dealing with completely independent particles, but if you want to constrain them to follow local motion too, you can set this to true.

## ◆ setMaterialName()

virtual void Ogre::ParticleSystem::setMaterialName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )
| virtual

Sets the name of the material to be used for this billboard set.

Parameters

  name | The new name of the material to use for this set.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ setNonVisibleUpdateTimeout()

void Ogre::ParticleSystem::setNonVisibleUpdateTimeout | ( | Real | timeout | ) |

Sets when the particle system should stop updating after it hasn't been visible for a while.

Remarks
  By default, visible particle systems update all the time, even when not in view. This means that they are guaranteed to be consistent when they do enter view. However, this comes at a cost, updating particle systems can be expensive, especially if they are perpetual.

  This option lets you set a 'timeout' on the particle system, so that if it isn't visible for this amount of time, it will stop updating until it is next visible.

Parameters

  timeout | The time after which the particle system will be disabled if it is no longer visible. 0 to disable the timeout and always update.

## ◆ setParticleEmitterRootNode()

void Ogre::ParticleSystem::setParticleEmitterRootNode | ( | SceneNode * | sceneNode | ) |

This is used to attach the particle Emmiters to an own node independent from the Scenenode the Particlesystem is attached to.

Remarks
  In case this scenenode is not NULL, particles will be emmitted relative to this node instead of relative to the Scenenode the Particlesystem is attached to.

## ◆ setParticleQuota()

void Ogre::ParticleSystem::setParticleQuota | ( | size_t | quota | ) |

Sets the maximum number of particles this system is allowed to have active at once.

Remarks
  Particle systems all have a particle quota, i.e. a maximum number of particles they are allowed to have active at a time. This allows the application to set a keep particle systems under control should they be affected by complex parameters which alter their emission rates etc. If a particle system reaches it's particle quota, none of the emitters will be able to emit any more particles. As existing particles die, the spare capacity will be allocated equally across all emitters to be as consistent to the original particle system style as possible. The quota can be increased but not decreased after the system has been created.

Parameters

  quota | The maximum number of particles this system is allowed to have.

## ◆ setRenderer()

void Ogre::ParticleSystem::setRenderer | ( | const String & | typeName | ) |

Sets the ParticleRenderer to be used to render this particle system.

Remarks
  The main ParticleSystem just manages the creation and movement of particles; they are rendered using functions in ParticleRenderer and the ParticleVisual instances they create.

Parameters

  typeName | String identifying the type of renderer to use; a new instance of this type will be created; a factory must have been registered with ParticleSystemManager.

## ◆ setRenderQueueGroup()

void Ogre::ParticleSystem::setRenderQueueGroup | ( | uint8 | queueID | ) |
| overridevirtual

Sets the render queue group this entity will be rendered through.

Remarks
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters

  queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.

  Valid render queue ids are between 0 & 254 inclusive

Reimplemented from Ogre::MovableObject.

## ◆ setRenderQueueSubGroup()

void Ogre::ParticleSystem::setRenderQueueSubGroup | ( | uint8 | subGroup | ) |

Sets the render queue sub group.

Remarks
  Within the same RenderQueue ID, you may want to have the renderables to have a specific order (i.e. have a mesh, but the hair submesh with alpha blending needs to be rendered last).

  RenderQueue Subgroups are useful for manually sorting objects, just like RenderQueue IDs. However, RenderQueue IDs can also be useful for skipping large number of objects through clever compositing and thus a performance optimization. Subgroups cannot be used for such optimizations.

Parameters

  subGroup | The sub group. This value can't exceed OGRE_MAKE_MASK( SubRqIdBits )

See also
  RenderQueue

## ◆ setSortingEnabled()

void Ogre::ParticleSystem::setSortingEnabled | ( | bool | enabled | ) |
| inline

Set whether or not particles are sorted according to the camera.

Remarks
  Enabling sorting alters the order particles are sent to the renderer. When enabled, particles are sent to the renderer in order of furthest distance from the camera.

## ◆ setSpeedFactor()

void Ogre::ParticleSystem::setSpeedFactor | ( | Real | speedFactor | ) |
| inline

Sets a 'speed factor' on this particle system, which means it scales the elapsed real time which has passed by this factor before passing it to the emitters, affectors, and the particle life calculation.

Remarks
  An interesting side effect - if you want to create a completely manual particle system where you control the emission and life of particles yourself, you can set the speed factor to 0.0f, thus disabling normal particle emission, alteration, and death.

## ◆ setTranslateParticleDirectionIntoWorldSpace()

void Ogre::ParticleSystem::setTranslateParticleDirectionIntoWorldSpace | ( | bool | value | ) |
| inline

Sets whether particles emitts in direction with is translated into worldspace or not (may only apply to some settings in regards of settings "Localspace" and "ParticleEmitterRootNode")

The documentation for this class was generated from the following file:

- OgreParticleSystem.h